//
// C++ Implementation: Capsule
//
// Description: 
//
//
// Author: Francois Faure <Francois.Faure@imag.fr>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "Capsule.h"

Capsule::Capsule( const SbVec3f& p1, const SbVec3f& p2 )
    : a(p1), b(p2)
{
    SbVec3f delta = b-a;
    length = delta.length();
    unitVector = delta * 1/length;
}


Capsule::~Capsule()
{
}

float Capsule::distance( const SbVec3f& p ) const
{
    SbVec3f ap = p-a;
    float projDist = unitVector.dot(ap);
    if( projDist<0 )
        return (p-a).length();
    else if( projDist>length )
        return (p-b).length();
    else return (p-( a+ unitVector*projDist) ).length();
}

